{{
  MotorControl
}}

CON
  _xinfreq = 5_000_000                      
  _clkmode = xtal1 | pll16x

OBJ
  PWM   : "PWMAsm.spin"

VAR
  long DirPinA, DirPinB
  

PUB Start( _DrivePin, _DirPinA, _DirPinB ) | ok

  DirPinA := _DirPinA
  DirPinB := _DirPinB

  DirA[ _DrivePin ] := 1
  DirA[ DirPinA ] := 1
  DirA[ DirPinB ] := 1

  ok := PWM.Start( _DrivePin )
  PWM.SetPeriod( constant(80_000_000 / 20_000) )

  SetSpeed( 0 )


PUB SetSpeed( Speed )

  if( Speed >= 0 )
    OutA[DirPinA] := 1
    OutA[DirPinB] := 0
  else
    OutA[DirPinA] := 0
    OutA[DirPinB] := 1

  PWM.SetDuty( 2 )
  'PWM.SetDuty( ||Speed )
                  